package zeenea.connector.openapi.client.model;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;

/**
 * Immutable implementation of {@link Response}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code ImmutableResponse.builder()}.
 */
@Generated(from = "Response", generator = "Immutables")
@SuppressWarnings({"all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.processing.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
public final class ImmutableResponse implements Response {
  private final @Nullable ValidatedResponse validResponse;

  private ImmutableResponse(@Nullable ValidatedResponse validResponse) {
    this.validResponse = validResponse;
  }

  /**
   * @return The value of the {@code validResponse} attribute
   */
  @JsonProperty("200")
  @Override
  public @Nullable ValidatedResponse getValidResponse() {
    return validResponse;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link Response#getValidResponse() validResponse} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for validResponse (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableResponse withValidResponse(@Nullable ValidatedResponse value) {
    if (this.validResponse == value) return this;
    return new ImmutableResponse(value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableResponse} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableResponse
        && equalTo(0, (ImmutableResponse) another);
  }

  private boolean equalTo(int synthetic, ImmutableResponse another) {
    return Objects.equals(validResponse, another.validResponse);
  }

  /**
   * Computes a hash code from attributes: {@code validResponse}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    int h = 5381;
    h += (h << 5) + Objects.hashCode(validResponse);
    return h;
  }

  /**
   * Prints the immutable value {@code Response} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return "Response{"
        + "validResponse=" + validResponse
        + "}";
  }

  /**
   * Utility type used to correctly read immutable object from JSON representation.
   * @deprecated Do not use this type directly, it exists only for the <em>Jackson</em>-binding infrastructure
   */
  @Generated(from = "Response", generator = "Immutables")
  @Deprecated
  @JsonDeserialize
  @JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.NONE)
  static final class Json implements Response {
    @Nullable ValidatedResponse validResponse;
    @JsonProperty("200")
    public void setValidResponse(@Nullable ValidatedResponse validResponse) {
      this.validResponse = validResponse;
    }
    @Override
    public ValidatedResponse getValidResponse() { throw new UnsupportedOperationException(); }
  }

  /**
   * @param json A JSON-bindable data structure
   * @return An immutable value type
   * @deprecated Do not use this method directly, it exists only for the <em>Jackson</em>-binding infrastructure
   */
  @Deprecated
  @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
  static ImmutableResponse fromJson(Json json) {
    ImmutableResponse.Builder builder = ImmutableResponse.builder();
    if (json.validResponse != null) {
      builder.validResponse(json.validResponse);
    }
    return builder.build();
  }

  /**
   * Creates an immutable copy of a {@link Response} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable Response instance
   */
  public static ImmutableResponse copyOf(Response instance) {
    if (instance instanceof ImmutableResponse) {
      return (ImmutableResponse) instance;
    }
    return ImmutableResponse.builder()
        .from(instance)
        .build();
  }

  /**
   * Creates a builder for {@link ImmutableResponse ImmutableResponse}.
   * <pre>
   * ImmutableResponse.builder()
   *    .validResponse(zeenea.connector.openapi.client.model.ValidatedResponse | null) // nullable {@link Response#getValidResponse() validResponse}
   *    .build();
   * </pre>
   * @return A new ImmutableResponse builder
   */
  public static ImmutableResponse.Builder builder() {
    return new ImmutableResponse.Builder();
  }

  /**
   * Builds instances of type {@link ImmutableResponse ImmutableResponse}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "Response", generator = "Immutables")
  @NotThreadSafe
  public static final class Builder {
    private @Nullable ValidatedResponse validResponse;

    private Builder() {
    }

    /**
     * Fill a builder with attribute values from the provided {@code Response} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    public final Builder from(Response instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable ValidatedResponse validResponseValue = instance.getValidResponse();
      if (validResponseValue != null) {
        validResponse(validResponseValue);
      }
      return this;
    }

    /**
     * Initializes the value for the {@link Response#getValidResponse() validResponse} attribute.
     * @param validResponse The value for validResponse (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @JsonProperty("200")
    public final Builder validResponse(@Nullable ValidatedResponse validResponse) {
      this.validResponse = validResponse;
      return this;
    }

    /**
     * Builds a new {@link ImmutableResponse ImmutableResponse}.
     * @return An immutable instance of Response
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableResponse build() {
      return new ImmutableResponse(validResponse);
    }
  }
}
