package zeenea.connector.openapi.client.model;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import java.util.Objects;
import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.concurrent.Immutable;
import javax.annotation.concurrent.NotThreadSafe;
import org.immutables.value.Generated;
import org.jetbrains.annotations.Nullable;

/**
 * Immutable implementation of {@link ValidatedResponse}.
 * <p>
 * Use the builder to create immutable instances:
 * {@code ImmutableValidatedResponse.builder()}.
 */
@Generated(from = "ValidatedResponse", generator = "Immutables")
@SuppressWarnings({"all"})
@SuppressFBWarnings
@ParametersAreNonnullByDefault
@javax.annotation.processing.Generated("org.immutables.processor.ProxyProcessor")
@Immutable
public final class ImmutableValidatedResponse
    implements ValidatedResponse {
  private final @Nullable String description;
  private final @Nullable Content content;

  private ImmutableValidatedResponse(
      @Nullable String description,
      @Nullable Content content) {
    this.description = description;
    this.content = content;
  }

  /**
   * @return The value of the {@code description} attribute
   */
  @JsonProperty("description")
  @Override
  public @Nullable String getDescription() {
    return description;
  }

  /**
   * @return The value of the {@code content} attribute
   */
  @JsonProperty("content")
  @Override
  public @Nullable Content getContent() {
    return content;
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ValidatedResponse#getDescription() description} attribute.
   * An equals check used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for description (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableValidatedResponse withDescription(@Nullable String value) {
    if (Objects.equals(this.description, value)) return this;
    return new ImmutableValidatedResponse(value, this.content);
  }

  /**
   * Copy the current immutable object by setting a value for the {@link ValidatedResponse#getContent() content} attribute.
   * A shallow reference equality check is used to prevent copying of the same value by returning {@code this}.
   * @param value A new value for content (can be {@code null})
   * @return A modified copy of the {@code this} object
   */
  public final ImmutableValidatedResponse withContent(@Nullable Content value) {
    if (this.content == value) return this;
    return new ImmutableValidatedResponse(this.description, value);
  }

  /**
   * This instance is equal to all instances of {@code ImmutableValidatedResponse} that have equal attribute values.
   * @return {@code true} if {@code this} is equal to {@code another} instance
   */
  @Override
  public boolean equals(@javax.annotation.Nullable Object another) {
    if (this == another) return true;
    return another instanceof ImmutableValidatedResponse
        && equalTo(0, (ImmutableValidatedResponse) another);
  }

  private boolean equalTo(int synthetic, ImmutableValidatedResponse another) {
    return Objects.equals(description, another.description)
        && Objects.equals(content, another.content);
  }

  /**
   * Computes a hash code from attributes: {@code description}, {@code content}.
   * @return hashCode value
   */
  @Override
  public int hashCode() {
    int h = 5381;
    h += (h << 5) + Objects.hashCode(description);
    h += (h << 5) + Objects.hashCode(content);
    return h;
  }

  /**
   * Prints the immutable value {@code ValidatedResponse} with attribute values.
   * @return A string representation of the value
   */
  @Override
  public String toString() {
    return "ValidatedResponse{"
        + "description=" + description
        + ", content=" + content
        + "}";
  }

  /**
   * Utility type used to correctly read immutable object from JSON representation.
   * @deprecated Do not use this type directly, it exists only for the <em>Jackson</em>-binding infrastructure
   */
  @Generated(from = "ValidatedResponse", generator = "Immutables")
  @Deprecated
  @JsonDeserialize
  @JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.NONE)
  static final class Json implements ValidatedResponse {
    @javax.annotation.Nullable String description;
    @javax.annotation.Nullable Content content;
    @JsonProperty("description")
    public void setDescription(@Nullable String description) {
      this.description = description;
    }
    @JsonProperty("content")
    public void setContent(@Nullable Content content) {
      this.content = content;
    }
    @Override
    public String getDescription() { throw new UnsupportedOperationException(); }
    @Override
    public Content getContent() { throw new UnsupportedOperationException(); }
  }

  /**
   * @param json A JSON-bindable data structure
   * @return An immutable value type
   * @deprecated Do not use this method directly, it exists only for the <em>Jackson</em>-binding infrastructure
   */
  @Deprecated
  @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
  static ImmutableValidatedResponse fromJson(Json json) {
    ImmutableValidatedResponse.Builder builder = ImmutableValidatedResponse.builder();
    if (json.description != null) {
      builder.description(json.description);
    }
    if (json.content != null) {
      builder.content(json.content);
    }
    return builder.build();
  }

  /**
   * Creates an immutable copy of a {@link ValidatedResponse} value.
   * Uses accessors to get values to initialize the new immutable instance.
   * If an instance is already immutable, it is returned as is.
   * @param instance The instance to copy
   * @return A copied immutable ValidatedResponse instance
   */
  public static ImmutableValidatedResponse copyOf(ValidatedResponse instance) {
    if (instance instanceof ImmutableValidatedResponse) {
      return (ImmutableValidatedResponse) instance;
    }
    return ImmutableValidatedResponse.builder()
        .from(instance)
        .build();
  }

  /**
   * Creates a builder for {@link ImmutableValidatedResponse ImmutableValidatedResponse}.
   * <pre>
   * ImmutableValidatedResponse.builder()
   *    .description(String | null) // nullable {@link ValidatedResponse#getDescription() description}
   *    .content(zeenea.connector.openapi.client.model.Content | null) // nullable {@link ValidatedResponse#getContent() content}
   *    .build();
   * </pre>
   * @return A new ImmutableValidatedResponse builder
   */
  public static ImmutableValidatedResponse.Builder builder() {
    return new ImmutableValidatedResponse.Builder();
  }

  /**
   * Builds instances of type {@link ImmutableValidatedResponse ImmutableValidatedResponse}.
   * Initialize attributes and then invoke the {@link #build()} method to create an
   * immutable instance.
   * <p><em>{@code Builder} is not thread-safe and generally should not be stored in a field or collection,
   * but instead used immediately to create instances.</em>
   */
  @Generated(from = "ValidatedResponse", generator = "Immutables")
  @NotThreadSafe
  public static final class Builder {
    private @javax.annotation.Nullable String description;
    private @javax.annotation.Nullable Content content;

    private Builder() {
    }

    /**
     * Fill a builder with attribute values from the provided {@code ValidatedResponse} instance.
     * Regular attribute values will be replaced with those from the given instance.
     * Absent optional values will not replace present values.
     * @param instance The instance from which to copy values
     * @return {@code this} builder for use in a chained invocation
     */
    public final Builder from(ValidatedResponse instance) {
      Objects.requireNonNull(instance, "instance");
      @Nullable String descriptionValue = instance.getDescription();
      if (descriptionValue != null) {
        description(descriptionValue);
      }
      @Nullable Content contentValue = instance.getContent();
      if (contentValue != null) {
        content(contentValue);
      }
      return this;
    }

    /**
     * Initializes the value for the {@link ValidatedResponse#getDescription() description} attribute.
     * @param description The value for description (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @JsonProperty("description")
    public final Builder description(@Nullable String description) {
      this.description = description;
      return this;
    }

    /**
     * Initializes the value for the {@link ValidatedResponse#getContent() content} attribute.
     * @param content The value for content (can be {@code null})
     * @return {@code this} builder for use in a chained invocation
     */
    @JsonProperty("content")
    public final Builder content(@Nullable Content content) {
      this.content = content;
      return this;
    }

    /**
     * Builds a new {@link ImmutableValidatedResponse ImmutableValidatedResponse}.
     * @return An immutable instance of ValidatedResponse
     * @throws java.lang.IllegalStateException if any required attributes are missing
     */
    public ImmutableValidatedResponse build() {
      return new ImmutableValidatedResponse(description, content);
    }
  }
}
